/**
	Copyright (c) 2009-2013 by Zoltan Palmer

	This file is part of FroZenLight.

    FroZenLight is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    FroZenLight is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with FroZenLight.  If not, see http://www.gnu.org/licenses/
*/
package lattice;
import math.VecMath;

import common.IConverter;

public class BoxAdapter<T extends Number> implements IBox<T> {

	protected IBox<T> box;
	@Override
	public byte location(T[] p) {
		return box.location(p);
	}
	@Override
	public byte locationLocal(T[] p) {
		return box.locationLocal(p);
	}
	@Override
	public boolean intersect(Ray<T> ray,T[] pnt) {
		return box.intersect(ray,pnt);
	}
	@Override
	public boolean localIntersect(Ray<T> ray,T[] pnt) {
		return box.localIntersect(ray,pnt);
	}
	@Override
	public boolean contains(T[] p) {
		return box.contains(p);
	}
	@Override
	public boolean containsLocal(T[] p) {
		return box.containsLocal(p);
	}
	@Override
	public T[] getCorner() {
		return box.getCorner();
	}
	@Override
	public void rotate(T[] p,T[] ax,T phi) {
		box.rotate(p,ax,phi);
	}
	@Override
	public void rotate(T[] p,T[] ax,T sinphi,T cosphi) {
		box.rotate(p,ax,sinphi,cosphi);
	}
	@Override
	public void setCorner(T[] c) {
		box.setCorner(c);
	}
	@Override
	public void setCenter(T[] c) {
		box.setCenter(c);
	}
	@Override
	public void setLength(T l) {
		box.setLength(l);
	}
	@Override
	public T[] getLengths() {
		return box.getLengths();
	}
	@Override
	public T[][] getSideVectors() {
		return box.getSideVectors();
	}
	@Override
	public T getLength(byte dir) {
		return box.getLength(dir);
	}
	@Override
	public void setLength(T l,byte dir) {
		box.setLength(l,dir);
	}
	@Override
	public IBox<T> copy() {
		return box.copy();
	}
	@Override
	public void setLengths(T[] ls) {
		box.setLengths(ls);
	}
	@Override
	public void local2WorldPoint(T[] v,T[] ret) {
		box.local2WorldPoint(v,ret);
	}
	@Override
	public void local2WorldVec(T[] v,T[] ret) {
		box.local2WorldVec(v,ret);
	}
	@Override
	public void world2LocalPoint(T[] v,T[] ret) {
		box.world2LocalPoint(v,ret);
	}
	@Override
	public void world2LocalVec(T[] v,T[] ret) {
		box.world2LocalVec(v,ret);
	}
	@Override
	public T[][] getBaseVectors() {
		return box.getBaseVectors();
	}
	@Override
	public <S extends Number>IBox<S> convert(IConverter<T,S> c,VecMath<S> smath) {
		return box.convert(c,smath);
	}
	@Override
    public void constrainLocal(T[] p,T[] ret) {
	    box.constrainLocal(p,ret);
    }
}
