/**
	Copyright (c) 2009-2013 by Zoltan Palmer

	This file is part of FroZenLight.

    FroZenLight is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    FroZenLight is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with FroZenLight.  If not, see http://www.gnu.org/licenses/
*/
package lattice;
import math.VecMath;

import common.IConverter;

public interface IShape<T extends Number> {

	void setCenter(T[] c);
	T[] getCenter();
	boolean reflect(Ray<T> r1,Ray<T> r2);
	public IShape<T> copy();
	void rotate(T[] p,T[] dir,T phi);
	void rotate(T[] p,T[] dir,T sinphi,T cosphi);
	void scale(T scale);
	boolean contains(T[] p);
	T getSize();
	void setSize(T s);
	public <S extends Number>IShape<S> convert(IConverter<T,S> c,VecMath<S> smath);
}
