/**
	Copyright (c) 2009-2013 by Zoltan Palmer

	This file is part of FroZenLight.

    FroZenLight is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    FroZenLight is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with FroZenLight.  If not, see http://www.gnu.org/licenses/
*/
package math;


public final class UtilFloat extends Util<Float> {

	public UtilFloat() {
		super();
	}
	@Override
	public Float getPi(int digits) {
		return new Float(Math.PI);
	}
	@Override
	public Float getE(int digit) {
		return (float)Math.E;
	}
	@Override
	public int precision(Float x) {
		return 8;
	}
	@Override
	public Float copy(Float x,int p) {
		return x;
	}
	@Override
	public Float cast(int i) {
		return new Float(i);
	}
	@Override
	public Float cast(float f) {
		return new Float(f);
	}
	@Override
	public Float cast(double d) {
		return new Float(d);
	}
	@Override
	public Float parse(String s) {
		return new Float(s);
	}
	@Override
	public Float[] array(int dim) {
		return new Float[dim];
	}
	@Override
	public Float[][] array(int d1,int d2) {
		return new Float[d1][d2];
	}
	@Override
	public int getScale(Float x) {
		return (int)(Math.floor(Math.log(x))+1);
	}
	@Override
	public Float round(Float x,int p) {
		if(p<8)
			return (float)(((long)(x*Math.pow(10,p)+0.5))*Math.pow(10,-p));
		return x;
	}
	@Override
	public Float expand(Float x, int p) {
		return x;
	}
	@Override
	public int getErrorScale(Float x) {
		return -8;
	}
}
