/**
	Copyright (c) 2009-2013 by Zoltan Palmer

	This file is part of FroZenLight.

    FroZenLight is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    FroZenLight is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with FroZenLight.  If not, see http://www.gnu.org/licenses/
*/
package math;


public final class VecMathDouble extends VecMath<Double> {

	public VecMathDouble() {super(new UtilDouble(),16,false,false);}
	public Double add(Double x, Double y) {return x+y;}
	public Double div(Double x, Double y) {return x/y;}
	public Double mul(Double x, Double y) {return x*y;}
	public Double mul(Double x, int i) {return x*i;}
	public Double neg(Double x) {return -x;}
	public Double sin(Double x) {return Math.sin(x);}
	public Double asin(Double x) {return Math.asin(x);}
	public Double cos(Double x) {return Math.cos(x);}
	public Double acos(Double x) {return Math.acos(x);}
	public Double tan(Double x) {return Math.tan(x);}
	public Double atan(Double x) {return Math.atan(x);}
	public Double sqrt(Double x) {return Math.sqrt(x);}
	public Double sqrt(Double x, int p) {return Math.sqrt(x);}
	public Double sub(Double x, Double y) {return x-y;}
	public byte cmp(Double x, Double y) {
		if(x<y) return -1;
		if(x>y) return 1;
		return 0;
	}
	public Double inv(Double x) {return 1/x;}
	public Double abs(Double x) {return Math.abs(x);}
	public Double mod(Double x, Double y) {return x%y;}
	public Double pow(Double x, int ex) {return Math.pow(x,ex);}
	public Double pow(Double x, Double y) {return Math.pow(x,y);}
	public byte sign(Double x) {return (byte) Math.signum(x);}
	public Double[] discrSinCos(float fact) {return sincos(fact*Math.PI);}
	public Double log(Double x) {return Math.log(x);}
}
