/**
	Copyright (c) 2009-2013 by Zoltan Palmer

	This file is part of FroZenLight.

    FroZenLight is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    FroZenLight is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with FroZenLight.  If not, see http://www.gnu.org/licenses/
*/
package pattern;
import java.awt.Component;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JProgressBar;
import javax.swing.WindowConstants;

@SuppressWarnings("serial")
final public class ProgressVisualizer extends JFrame
        implements LightPatternSolver.IProgressListener {

	private JProgressBar bar;
	private JLabel text;
	public ProgressVisualizer(String pattern,Component cp) {
		super("Calculating Pattern "+pattern);
		setLocationRelativeTo(cp);
		setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
		GridBagLayout gridbag = new GridBagLayout();
		GridBagConstraints c = new GridBagConstraints();
		getContentPane().setLayout(gridbag);
		c.fill = GridBagConstraints.BOTH;
		c.gridx = 0;
		c.gridy = 0;
		c.weightx = 1;
		c.weighty = 1;
		c.insets = new Insets(5,5,0,5);
		text = new JLabel("Initialize ...");
		gridbag.setConstraints(text,c);
		getContentPane().add(text);
		c.fill = GridBagConstraints.BOTH;
		c.gridx = 0;
		c.gridy = 1;
		c.weightx = 1;
		c.weighty = 1;
		c.insets = new Insets(5,5,5,5);
		bar = new JProgressBar(0,1);
		gridbag.setConstraints(bar,c);
		getContentPane().add(bar);
		pack();
		setSize(400,80);
		setVisible(true);
	}
	@Override
	public void updateAccuracy(int digits,int maxDigits) {
		if(bar.getMaximum()!=maxDigits)
			bar.setMaximum(maxDigits);
		text.setText("Accuracy: "+digits+" / "+maxDigits+" digits");
		bar.setValue(digits);
	}
}
