/**
	Copyright (c) 2009-2012 by Zoltan Palmer

	This file is part of FroZenLight.

    FroZenLight is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    FroZenLight is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with FroZenLight.  If not, see http://www.gnu.org/licenses/
*/
package test;
import junit.framework.TestCase;
import math.VecMathApfloat;

import org.apfloat.Apfloat;

import pattern.LightPatternSolver;

public class LightPatternSolverTest {

	private final static float DELTA = 0.000000000000001f;
	public void testLinesAngleDelta() {
		VecMathApfloat math = new VecMathApfloat((short)100);
		LightPatternSolver<Apfloat> solver = new LightPatternSolver<Apfloat>(1/4f,false,math);
		double phi1 = -Math.PI/4;
		double phi2 = Math.PI/2;
		double res = Math.PI/4;
		TestCase.assertEquals("delta phi",res,solver.linesAngleDelta(phi1,phi2),DELTA);
		phi1 = Math.PI/4;
		phi2 = -Math.PI/2;
		res = Math.PI/4;
		TestCase.assertEquals("delta phi",res,solver.linesAngleDelta(phi1,phi2),DELTA);
		phi1 = -Math.PI/8;
		phi2 = Math.PI/8;
		res = Math.PI/4;
		TestCase.assertEquals("delta phi",res,solver.linesAngleDelta(phi1,phi2),DELTA);
		phi1 = 5*Math.PI/8;
		phi2 = 3*Math.PI/8;
		res = Math.PI/4;
		TestCase.assertEquals("delta phi",res,solver.linesAngleDelta(phi1,phi2),DELTA);
		phi1 = -5*Math.PI/8;
		phi2 = -3*Math.PI/8;
		res = Math.PI/4;
		TestCase.assertEquals("delta phi",res,solver.linesAngleDelta(phi1,phi2),DELTA);
		phi1 = -3*Math.PI/8;
		phi2 = 3*Math.PI/8;
		res = Math.PI/4;
		TestCase.assertEquals("delta phi",res,solver.linesAngleDelta(phi1,phi2),DELTA);
	}
}
